/*
 * aufgabe4.c
 *
 *  Created on: 04.12.2012
 *      Author: Johann
 */

#include<stdio.h>
#include<stdlib.h>
#include<math.h>


// Funktionsdeklaration

double **neueMatrix(int N_zeilen, int N_spalten);
void zeigeMatrix(double** matrix, int N_zeilen, int N_spalten);
void loescheMatrix(double** matrix, int N_zeilen);

void initHilbertMatrix(double** matrix, int N);

// Hauptprogramm
int main(void)
{
	setvbuf(stdout, NULL, _IONBF, 0);    /*Die Standard-Ausgabe wird nicht gepuffert*/
  int N;
  double **H;

  printf("Dimension N der Matrix: ");
  scanf("%i", &N);

  H = neueMatrix(N, N);

  // Berechne Hilbertmatrix
  initHilbertMatrix(H, N);

  // Ausgabe
  zeigeMatrix(H, N, N);

  // Speicher freigeben
  loescheMatrix(H, N);

  return 0;
}


//  Funktionsdefinition


// Speicher fr Matrizen
double **neueMatrix(int N_zeilen, int N_spalten)
{
  int i, j;
  double **matrix;

  matrix = (double **)malloc(N_zeilen * sizeof(double *));
  if (NULL == matrix)
    return NULL;

  for (i = 0; i < N_zeilen; i++)
  {
    matrix[i] = (double *)malloc(N_spalten * sizeof(double));
    if (NULL == matrix[i])
    {
      for (j = 0; j < i; j++)
	free(matrix[j]);
      free(matrix);
      return NULL;
    }
  }
  return matrix;
}

// Ausgabe von Matrizen auf dem Bildschrim
void zeigeMatrix(double** matrix, int N_zeilen, int N_spalten)
{
  int i, j;

  for (i = 0; i < N_zeilen; i++)
  {
    for (j = 0; j < N_spalten; j++)
      printf("%.4lf ", matrix[i][j]);
    printf("\n");
  }
}

// Speicher wieder freigeben
void loescheMatrix(double **matrix, int N_zeilen)
{
  int i;
  for (i = 0; i < N_zeilen; i++)
    free(matrix[i]);

  free(matrix);
}

// Berechnung der Hilbert Matrix

void initHilbertMatrix(double **matrix, int N)
{
  int i, j;
  for (i = 1; i <= N; i++)
  {
    for (j = 1; j <= N; j++)
    	matrix[i-1][j-1]=1.0/(i+j-1.0);
  }
}
